/*******************************************************************************
 *
 * File Name: neuralNetworkUpdateAlgorithm.h
 * Author: Richard Baxter
 * Project: Advanced Neural Network (ANN) - Fractal Based Neural Network
 * Project Version: 1b13d 29-Sept-07
 * Comments:
 *
 *******************************************************************************/

 //IMPORTANT CODING NOTE - on 10-dec-06/1b6b I have started to remove the neuronReference class as circular referencing does not appear to be allowed in C++
//NB when create NeuronList class change all referecnes to "...List->frontNeuronReferences.." to "...List->neuronReferences" as Neurons when declared for the purpose of creating neuron lists only have their frontNeuronReferences used


#include "neuronClass.h"

double neuralNetworkBackPropogationPass(Neuron * firstInputNeuron, Neuron * firstOutputNeuron);

#ifdef ANN

void copyNeuronListIntoNeuronReferenceArray(Neuron * neuronReferenceArrayToUpdate[], Neuron * firstNeuronInListToCopy);
void copyNeuronReferenceArrayIntoNeuronList(Neuron * firstNeuronInListToUpdate, Neuron * neuronReferenceArrayToCopy[]);
void copyNeuronReferenceArray(Neuron * neuronReferenceArrayToUpdate[], Neuron * neuronReferenceArrayToCopy[], long numberOfNeuronsInReferenceArray);

#endif

float calculateOValue(float netValue);

